Subject: Re: bug#60996: 29.0.60; Native compile fails to remove temp file for trampoline

From: Eli Zaretskii <[email-masked]>
Date: Mon, 23 Jan 2023 16:58:28 +0200

> From: Andy Moreton <[email-masked]>
> Date: Mon, 23 Jan 2023 02:30:43 +0000
> 
> >From more expermenting with a debug build in gdb, it seem to be related
> to this code in native-elisp-load:
> 
>       /* If in this session there was ever a file loaded with this
> 	 name, rename it before loading, to make sure we always get a
> 	 new handle!  */
>       Lisp_Object tmp_filename =
> 	Fmake_temp_file_internal (filename, Qnil, build_string (".eln.tmp"),
> 				  Qnil);
>       if (NILP (Ffile_writable_p (tmp_filename)))
> 	comp_u->handle = dynlib_open_for_eln (SSDATA (encoded_filename));
>       else
> 	{
> 	  Frename_file (filename, tmp_filename, Qt);
> 	  comp_u->handle = dynlib_open_for_eln (SSDATA (ENCODE_FILE (tmp_filename)));
> 	  Frename_file (tmp_filename, filename, Qnil);
> 	}
> 
> The renaming results in the ".eln.tmp" suffixed name having an open
> handle. That handle is still open when other code tries to delete
> the renamed ".eln" file, which fails.

The question is: why is that .eln.tmp file still open when we are
trying to delete it?  I hoped we'd be able to establish that, so that
we could decide what to do about it.  But I don't yet see the
information which would explain why the file is still open.

Do these *.eln.tmp file remain in %TEMP% after Emacs startup?  If they
remain there, then what happens if you exit Emacs and restart it? do
these files remain there or are they deleted?  IOW, if we just ignore
these errors (e.g., by ignore-error), would the problem be fixed, or
will there be left-overs?

> The attached .csv file shows filesystem activity captured by Process
> Monitor for the relevant "...\comp-lambda-*" temp files during emacs
> startup. (It may be easier to read if imported into a spreadsheet).

Maybe I don't understand how to read this, but I cannot find any
traces for the failed deletion of a .eln.tmp file.  The only failure
to delete is this:

> "14:15:24.8773402","emacs.exe","6452","SetDispositionInformationEx","C:\Users\ajm\AppData\Local\Temp\comp-lambda-SGvFx7.eln","CANNOT DELETE","Flags: FILE_DISPOSITION_DELETE, FILE_DISPOSITION_POSIX_SEMANTICS, FILE_DISPOSITION_FORCE_IMAGE_SECTION_CHECK"

and it names a .eln file, not .eln.tmp.  I also don't see any
RenameFile calls, but maybe they appear under different names in this
captured activity?

> > We need to know which code opened it the last time and didn't close
> > it.  Can you figure that out?  All the files Emacs opens go through 2
> > functions in w32.c: sys_fopen and sys_open, so by running with 2
> > breakpoints there that show the backtrace and continue, you should be
> > able to see the culprit, and we can then take it from there.
> 
> As noted above, I think it is the code in native-elisp-load interacting
> woth the way that the files are renamed (and if those operations have
> specified posix semantics or not). 

I don't think I follow.  The snippet from native-elisp-load you show
doesn't call Fdelete_file, it only renames files, and renaming should
work on MS-Windows like it works on Posix systems in this case.  The
problem, as the error message evidences, is in Fdelete_file.

Frename_file indeed can call Fdelete_file, but rename-file is not in
the backtraces you posted, so I don't think this code is involved
directly.  You seem to say this code somehow "interferes" with
deleting files, but how does it interfere with that?  Also, AFAIK this
part of comp.c didn't change since Emacs 28, so whatever caused the
problem is not this code directly, but something else.

IOW, I'd still like to understand in more detail what changed lately
that causes these errors in your case.

> >> I am not sure excactly when this issue started, but I did not see it in
> >> emacs-29 or master bootstrapped before this month.
> >
> > Could be because we now compile trampolines differently (to avoid the
> > danger of the "fork bomb" due to recursive compilation of
> > trampolines by async subprocesses).
> 
> Any idea when those changes were committed, and which changesets ? IT
> doesn't apper obvios from the commit history.

See commit 1a8015b837.  Maybe also commit 5fec9182db.

Thanks.